function y = TPSpoint(x,y,xi,yi,a,b)

% Thin plate splines function
% x,y = point to calculate the TPS value (both scalars)
% xi,yi = vectors of original data points
% a = vector of weights (from the CalculateAandB.m function)
% b = vector of adjustments (length 3, from the CalculateAandB.m function)

% By Fabrice Douglas Rouah at wwww.FRouah.com, wwww.Volopta.com

N = length(xi);

for k=1:N
    z1 = x - xi(k);
    z2 = y - yi(k);
    r = z1^2 + z2^2;    % Squared norm
    if r == 0
        A(k) = 0;       % Zero if r=0
    else
        A(k) = a(k)*(r)*log(r);
    end
end

y = sum(A) + b(1) + b(2)*x + b(3)*y;




        